'----------------------------------------------------------------------------
'  ParadiseDialup.vbs (v1.0)
'----------------------------------------------------------------------------
'
' Retreives the number of used and total prepaid hours of usage for a
' paradise.net.nz dialup account.
'
' NOTES:Set your username and password below for this script to work
'      	correctly.
'
' 	- Execute the "updateUsage" function to update your Paradise
' 	usage. Ignore any warnings from antivirus software that this 
'	is a malicious script (it just writes a small .tmp file to your
'	Configs directory to save bandwidth)
'
'	- The "updateUsage" function should only be run every 60 min in
'	Samurize; Paradise only update your stats every 60 min and it
'	is a waste of bandwidth checking the usage every say 5min! Set
'	the other functions to update more often (say every 5 min) to
' 	ensure the usage is kept up-to-date.
'
'
'									-NeM
'
'----------------------------------------------------------------------------

'========================================================
' ENTER YOUR ACCOUNT DETAILS HERE:
' --------------------------------

USER_NAME = "username"	' your Paradise account user name
PASSWORD = "password"	' your Paradise account password

'========================================================

' =============================================================
' PREFERENCES
' ===========
'
' Please choose the style you want the date to appear as.
' (NOTE: this is for the formattedDate function only)
'
' eg. for the 21st of Febuary 2003:
' (1) 21 Feb
' (2) 21 Feb 03
' (3) 21/02
' (4) 21/02/03

DATE_STYLE = 4
' =============================================================

'DO NOT CHANGE THE FOLLOWING DEFINITIONS:
'#######################################################
TMP_FILE = "ParadiseDialup.tmp"
PRE_TRAFFIC = "<td align=""RIGHT"" bgcolor=""#555555"">"
'#######################################################

' *** FUNCTIONS USED BY SAMURIZE ***

Function getTotalHours()
	getTotalHours = getUsage(1)
End Function

Function getUsedHours()
	getUsedHours = getUsage(2)
End Function

Function getPeriodEndDate()

	dim strAllInfo

	htmlResult = ReturnHTML("https://" & USER_NAME & ":" & PASSWORD & "@www.paradise.net.nz/cgi-bin/members/usage/show-dialin-usage")

	strAllInfo = readFile(TMP_FILE)

	checkFile = InStr(strAllInfo, "All Billing Periods...")

	If checkFile > 0 Then

		' cut past all the links
		Do
			strAllInfo = Mid(strAllInfo, InStr(strAllInfo, "href=")+5)
		Loop Until InStr(strAllInfo, "href=") <= 0

		strAllInfo = Mid(strAllInfo, InStr(strAllInfo, " to ")+4)

		getPeriodEndDate = Mid(strAllInfo, 1, InStr(strAllInfo, "</a>")-1)

	Else
		getPeriodEndDate = "error"
		Exit Function
	End If

End Function

Function formattedDate()

	style = getPeriodEndDate()

	If DATE_STYLE > 2 Then
		dateString = mid(style, 9, 2) & "/" & mid(style, 6, 2)
		If DATE_STYLE = 4 Then
			dateString = dateString & "/" & mid(style, 3, 2)
		End If
	End If

	If DATE_STYLE < 3 Then
		dateString = mid(style, 9, 2) & " " & numToMonthName(CInt(mid(style, 6, 2)))
		If DATE_STYLE = 2 Then
			dateString = dateString & " " & mid(style, 3, 2)
		End If
	End If

	formattedDate = dateString

End Function

Function updateUsage()

	dim fs,f,htmlResult

	htmlResult = ReturnHTML("https://" & USER_NAME & ":" & PASSWORD & "@www.paradise.net.nz/cgi-bin/members/usage/show-dialin-usage")

	checkFile = InStr(htmlResult, "<title>paradise.net - Show Dialin Usage</title>")

	If checkFile > 0 Then

		' Minimise the temp file size and read/write times
		htmlResult = Mid(htmlResult, InStr(htmlResult, "All Billing Periods..."))
		htmlResult = Mid(htmlResult, 1, InStr(htmlResult, "</table>"))

		set fs=CreateObject("Scripting.FileSystemObject")
		set f=fs.CreateTextFile(TMP_FILE,true)
		f.write(htmlResult)
		f.close
		set f=nothing
		set fs=nothing

		updateUsage = "Paradise usage successfully updated."

	Else
		updateUsage = "Error retreiving usage. Check your username and password."
	End If

End Function

' *** END OF FUNCTIONS USED BY SAMURIZE ***



Private function getUsage(j)

	dim strAllInfo, status

	strAllInfo = readFile(TMP_FILE)

	checkFile = InStr(strAllInfo, "All Billing Periods...")

	If checkFile > 0 Then

		If InStr(strAllInfo, PRE_TRAFFIC) = 0 Then
			' The new billing period hasn't been posted yet
			PRE_TRAFFIC = "<td align=""RIGHT"" bgcolor=""#333333"">"
		End If

		' cut past all the links
		Do
			strAllInfo = Mid(strAllInfo, InStr(strAllInfo, "href=")+5)
		Loop Until InStr(strAllInfo, "href=") <= 0

		For i = 1 to j
			' skip past the unwanted usage stats
			strAllInfo = Mid(strAllInfo, InStr(strAllInfo, PRE_TRAFFIC)+Len(PRE_TRAFFIC))
		Next

		' grab the usage stats we are interested in
		getUsage = Mid(strAllInfo, 1, InStr(strAllInfo, "</td>")-1)
		

	Else
		' could not read traffic usage from file
		getUsage = "error"
		Exit Function
	End If

End FUnction

Private Function numToMonthName(num)

	Select Case num

	Case 1
		numToMonthName = "Jan"
	Case 2
		numToMonthName = "Feb"
	Case 3
		numToMonthName = "Mar"
	Case 4
		numToMonthName = "Apr"
	Case 5
		numToMonthName = "May"
	Case 6
		numToMonthName = "Jun"
	Case 7
		numToMonthName = "Jul"
	Case 8
		numToMonthName = "Aug"
	Case 9
		numToMonthName = "Sep"
	Case 10
		numToMonthName = "Oct"
	Case 11
		numToMonthName = "Nov"
	Case 12
		numToMonthName = "Dec"

	End Select

End Function

Private Function readFile(fileName)

	dim contents

	Set fs = CreateObject ("Scripting.FileSystemObject")
        If (fs.FileExists(TMP_FILE)) Then
		Set filePath = fs.GetFile(TMP_FILE)
		set File = filePath.OpenAsTextStream (1, -2)

		contents = file.readall

		File.Close ' Closes the file
		Set filePath = nothing
		Set fs = nothing
		Set File = nothing
	Else 
		Exit Function
        End If

	' return file contents
	readFile = contents

End Function

Private Function ReturnHTML(sURL)
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	HTML = objXMLHTTP.responseBody
	Set objRS = CreateObject("ADODB.Recordset")
	objRS.Fields.Append "txt", 200, 45000, &H00000080
	objRS.Open
	objRS.AddNew
	objRS.Fields("txt").AppendChunk HTML
	ReturnHTML = objRS("txt").Value
	objRS.Close
	Set objRS = Nothing
	Set objXMLHTTP = Nothing
End Function
